# IR-PC-HID-Remote

## Fernbedienung Hauppauge

![](ir-fb.jpg)

Diese Fernbedienung sendet RC5 12-bit Codes. 

RC5-Fernbedienungen wechseln bei jedem Tastendruck ein Togglebit, so dass der "Adressteil" des Codes 2 abwechselnde Werte hat, d.h. dies wechselt bei jedem Tastendruck. Hält man eine Taste gedrückt, wird sie fortlaufend mit dem selben Togglebit erneut gesendet, so dass ein Wechsel eindeutig aussagt, dass die Taste dazwischen losgelassen wurde. 

Die IRremote library erzeugt daraus 3-stellige HEX codes, deren erste Stelle (in meinem Code als prefix bezeichnet) je nach Status des Togglebit immer 7 oder F ist. 

IR-Code demzufolge: 0x7** oder 0xF** - ** siehe Tabelle

Tastenzuordnung

| Fernbedienung                | IR-Code | Tastencode                                                   |
| ---------------------------- | ------- | ------------------------------------------------------------ |
| Home/Go                      | BB      | Task Switch <br />kurz: Windows-Taste, <br />etwas länger: ALT+TAB (danach kurz: TAB), <br />noch länger: ALT+F4 |
| Power                        | BD      | System Sleep (kurz), <br />Shutdown (lang)                   |
| TV                           | 9C      | CTRL+ALT+WIN+F1                                              |
| Videos                       | 98      | CTRL+ALT+WIN+F2                                              |
| Music                        | 99      | CTRL+ALT+WIN+F3                                              |
| Pictures                     | 9A      | CTRL+ALT+WIN+F4                                              |
| Guide                        | 9B      | CTRL+ALT+WIN+F5                                              |
| Radio                        | 8C      | CTRL+ALT+WIN+F6                                              |
| Pfeil nach links &larr;      | 96      | &larr; PFEIL LINKS                                           |
| Pfeil nach oben &uarr;       | 94      | &uarr; PFEIL OBEN                                            |
| Pfeil nach rechts &rarr;     | 97      | &rarr; PFEIL RECHTS                                          |
| Pfeil nach unten &darr;      | 95      | &darr; PFEIL UNTEN                                           |
| OK                           | A5      | RETURN                                                       |
| Back/Exit                    | 9F      | BACKSPACE                                                    |
| i/MENU                       | 8D      | ESC                                                          |
| Prev.Ch                      | A4      | C (Kodi Kontextmenü)                                         |
| Volume +                     | 90      | MEDIA VOLUME UP  (repeat aktiv)                              |
| Volume -                     | 91      | MEDIA VOLUME DOWN  (repeat aktiv)                            |
| Volume Mute                  | 8F      | MEDIA VOLUME MUTE                                            |
| CH +                         | A0      | PAGE UP                                                      |
| CH -                         | A1      | PAGE DOWN                                                    |
| &#9673;  REC                 | B7      | [derzeit nicht belegt]                                       |
| &#9724;  STOP                | B6      | MEDIA STOP                                                   |
| &#9658;  PLAY                | B5      | MEDIA PLAY/PAUSE                                             |
| &#10074;&#10074;  PAUSE      | B0      | MEDIA PLAY/PAUSE                                             |
| &#9668;&#9668;  REWIND       | B2      | MEDIA REWIND  (repeat aktiv)                                 |
| &#9658;&#9658;  FAST FORWARD | B4      | MEDIA FAST FORWARD  (repeat aktiv)                           |
| &#10074;&#9668;  PREVIOUS    | A4      | MEDIA PREVIOUS TRACK                                         |
| &#9658;&#10074;  NEXT        | 9E      | MEDIA NEXT TRACK                                             |
| 1                            | 81      | 1                                                            |
| 2                            | 82      | 2                                                            |
| 3                            | 83      | 3                                                            |
| 4                            | 84      | 4                                                            |
| 5                            | 85      | 5                                                            |
| 6                            | 86      | 6                                                            |
| 7                            | 87      | 7                                                            |
| 8                            | 88      | 8                                                            |
| 9                            | 89      | 9                                                            |
| 0                            | 80      | 0                                                            |
| *                            | 8A      | [derzeit nicht belegt]                                       |
| #                            | 8E      | [derzeit nicht belegt]                                       |
| RED                          | 8B      | CTRL+ALT+WIN+F7                                              |
| GREEN                        | AE      | CTRL+ALT+WIN+F8                                              |
| YELLOW                       | B8      | CTRL+ALT+WIN+F9                                              |
| BLUE                         | A9      | CTRL+ALT+WIN+F10                                             |


